#define N 16
struct rec
{
   char s[4][16];
};

typedef struct rec sbox;

char getbit(char x,int p)
{
	return(x>>(p-1) & 1);
}

char setbit(char x,int p)
{
	return(x|((x>>(p-1)|1)<<(p-1)));
}

char reset(char x,int p)
{
	return(x & ~(1<<(p-1)));
}

char getbits(char x,int p,int n)
{
	return(x>>(p-n) & ~(~0<<n));
}


char assign(char x,char y,int p)
{
    if(y & 1)
       x=setbit(x,p);
    else
       x=reset(x,p);
    return(x);
    
}     

void change(char *data,char *a,int x,int y)
{
     char temp;
     temp = getbit(data[(x-1)/8],((x-1)%8)+1);
     a[(y-1)/8]=assign(a[(y-1)/8],temp,(((y-1)%8)+1)); 
}

char *initial_permute(char *data)
{
     char *a;
     a=(char*)malloc(sizeof(char)*8);
     change(data,a,1,40);
     change(data,a,2,8);
     change(data,a,3,48);
     change(data,a,4,16);
     change(data,a,5,56);
     change(data,a,6,24);
     change(data,a,7,64);
     change(data,a,8,32);
     change(data,a,9,39);
     change(data,a,10,7);
     change(data,a,11,47);
     change(data,a,12,15);
     change(data,a,13,55);
     change(data,a,14,23);
     change(data,a,15,63);
     change(data,a,16,31);
     change(data,a,17,38);
     change(data,a,18,6);
     change(data,a,19,46);
     change(data,a,20,14);
     change(data,a,21,54);
     change(data,a,22,22);
     change(data,a,23,62);
     change(data,a,24,30);
     change(data,a,25,37);
     change(data,a,26,5);
     change(data,a,27,45);
     change(data,a,28,13);
     change(data,a,29,53);
     change(data,a,30,21);
     change(data,a,31,61);
     change(data,a,32,29);
     change(data,a,33,36);
     change(data,a,34,4);
     change(data,a,35,44);
     change(data,a,36,12);
     change(data,a,37,52);
     change(data,a,38,20);
     change(data,a,39,60);
     change(data,a,40,28);
     change(data,a,41,35);
     change(data,a,42,3);
     change(data,a,43,43);
     change(data,a,44,11);
     change(data,a,45,51);
     change(data,a,46,19);
     change(data,a,47,59);
     change(data,a,48,27);
     change(data,a,49,34);
     change(data,a,50,2);
     change(data,a,51,42);
     change(data,a,52,10);
     change(data,a,53,50);
     change(data,a,54,18);
     change(data,a,55,58);
     change(data,a,56,26);
     change(data,a,57,33);
     change(data,a,58,1);
     change(data,a,59,41);
     change(data,a,60,9);
     change(data,a,61,49);
     change(data,a,62,17);
     change(data,a,63,57);
     change(data,a,64,25);
     return(a);
    
}


char * inverse_permute(char *data)
{
     char *a;
     a=(char*)malloc(sizeof(char)*8);
     change(data,a,40,1);
     change(data,a,8,2);
     change(data,a,48,3);
     change(data,a,16,4);
     change(data,a,56,5);
     change(data,a,24,6);
     change(data,a,64,7);
     change(data,a,32,8);
     change(data,a,39,9);
     change(data,a,7,10);
     change(data,a,47,11);
     change(data,a,15,12);
     change(data,a,55,13);
     change(data,a,23,14);
     change(data,a,63,15);
     change(data,a,31,16);
     change(data,a,38,17);
     change(data,a,6,18);
     change(data,a,46,19);
     change(data,a,14,20);
     change(data,a,54,21);
     change(data,a,22,22);
     change(data,a,62,23);
     change(data,a,30,24);
     change(data,a,37,25);
     change(data,a,5,26);
     change(data,a,45,27);
     change(data,a,13,28);
     change(data,a,53,29);
     change(data,a,21,30);
     change(data,a,61,31);
     change(data,a,29,32);
     change(data,a,36,33);
     change(data,a,4,34);
     change(data,a,44,35);
     change(data,a,12,36);
     change(data,a,52,37);
     change(data,a,20,38);
     change(data,a,60,39);
     change(data,a,28,40);
     change(data,a,35,41);
     change(data,a,3,42);
     change(data,a,43,43);
     change(data,a,11,44);
     change(data,a,51,45);
     change(data,a,19,46);
     change(data,a,59,47);
     change(data,a,27,48);
     change(data,a,34,49);
     change(data,a,2,50);
     change(data,a,42,51);
     change(data,a,10,52);
     change(data,a,50,53);
     change(data,a,18,54);
     change(data,a,58,55);
     change(data,a,26,56);
     change(data,a,33,57);
     change(data,a,1,58);
     change(data,a,41,59);
     change(data,a,9,60);
     change(data,a,49,61);
     change(data,a,17,62);
     change(data,a,57,63);
     change(data,a,25,64);
     return(a);
}

char* expansion_permute(char *data)
{
   char *right;
   char x;
   right = (char*)malloc(sizeof(char)*6);
   change(data,right,1,2);
   change(data,right,1,48);
   change(data,right,2,3);
   change(data,right,3,4);
   change(data,right,4,5);
   change(data,right,4,7);
   change(data,right,5,6);
   change(data,right,5,8);
   change(data,right,6,9);
   change(data,right,7,10);
   change(data,right,8,11);
   change(data,right,8,13);
   change(data,right,9,12);
   change(data,right,9,14);
   change(data,right,10,15);
   change(data,right,11,16);
   change(data,right,12,17);
   change(data,right,12,19);
   change(data,right,13,18);
   change(data,right,13,20);
   change(data,right,14,21);
   change(data,right,15,22);
   change(data,right,16,23);
   change(data,right,16,25);
   change(data,right,17,24);
   change(data,right,17,26);
   change(data,right,18,27);
   change(data,right,19,28);
   change(data,right,20,29);
   change(data,right,20,31);
   change(data,right,21,30);
   change(data,right,21,32);
   change(data,right,22,33);
   change(data,right,23,34);
   change(data,right,24,35);
   change(data,right,24,37);
   change(data,right,25,36);
   change(data,right,25,38);
   change(data,right,26,39);
   change(data,right,27,40);
   change(data,right,28,41);
   change(data,right,28,43);
   change(data,right,29,42);
   change(data,right,29,44);
   change(data,right,30,45);
   change(data,right,31,46);
   change(data,right,32,47);
   change(data,right,32,1);
   return(right);
} 
   
 char* key_compression(char *key)
{
  char *comp;
  int count = 1,i;
  comp = (char*)malloc(sizeof(char)*7);
  for(i=1;i<=64;i++)
  {
     if(i%8 != 0)
     {
       change(key,comp,i,count);
       count++;
     }
  }
  return(comp);
}

void  rotate(char *key,int m)
{   
   int i,j;
   char first,next28,msb;
   for(j=0;j<m;j++)
   {
         first=getbit(key[0],8);
	 next28=getbit(key[3],4);
	 key[0]<<1;
   	 for(i=1;i<8;i++)
    	{
    		msb=getbit(key[i],8);
		key[i]<<1;
		key[i-1]|=msb;
     	}
	key[3]=assign(key[3],first,4);
	key[6]=assign(key[6],next28,1);
    }
}

void select48(char *key_temp,char *key_48)
{
      change(key_temp,key_48,1,5);	      
      change(key_temp,key_48,2,24);	      
      change(key_temp,key_48,3,7);	      
      change(key_temp,key_48,4,16);	      
      change(key_temp,key_48,5,6);	      
      change(key_temp,key_48,6,10);	      
      change(key_temp,key_48,7,20);	      
      change(key_temp,key_48,8,18);	      
      change(key_temp,key_48,10,12);	      
      change(key_temp,key_48,11,3);	      
      change(key_temp,key_48,12,15);	      
      change(key_temp,key_48,13,23);	      
      change(key_temp,key_48,14,1);	      
      change(key_temp,key_48,15,9);	      
      change(key_temp,key_48,16,19);	      
      change(key_temp,key_48,17,2);	      
      change(key_temp,key_48,19,14);	      
      change(key_temp,key_48,20,22);	      
      change(key_temp,key_48,21,11);	      
      change(key_temp,key_48,23,13);	      
      change(key_temp,key_48,24,4);	      
      change(key_temp,key_48,26,17);	      
      change(key_temp,key_48,27,21);	      
      change(key_temp,key_48,28,8);	      
      change(key_temp,key_48,29,47);	      
      change(key_temp,key_48,30,31);	      
      change(key_temp,key_48,31,27);	      
      change(key_temp,key_48,32,48);	      
      change(key_temp,key_48,33,35);	      
      change(key_temp,key_48,34,41);	      
      change(key_temp,key_48,36,46);	      
      change(key_temp,key_48,37,28);	      
      change(key_temp,key_48,39,39);	      
      change(key_temp,key_48,40,32);	      
      change(key_temp,key_48,41,25);	      
      change(key_temp,key_48,42,44);	      
      change(key_temp,key_48,44,37);	      
      change(key_temp,key_48,45,34);	      
      change(key_temp,key_48,46,43);	      
      change(key_temp,key_48,47,29);	      
      change(key_temp,key_48,48,36);	      
      change(key_temp,key_48,49,38);	      
      change(key_temp,key_48,50,45);	      
      change(key_temp,key_48,51,33);	      
      change(key_temp,key_48,52,26);	      
      change(key_temp,key_48,53,42);	      
      change(key_temp,key_48,55,30);	      
      change(key_temp,key_48,56,40);	      
 }   
 
char get_val(char m)
{
  switch(m)
  {
    case 'a': return(10);
    case 'b': return(11);
    case 'c': return(12);
    case 'd': return(13);
    case 'e': return(14);
    case 'f': return(15);
    default : return(m);
  }
}  
               
char*  s_box(char *right_data)
{
	char *right;
	FILE *fp;
	sbox table;
        int row=0,col=0,j=1,k,i;
	char temp;
	right=(char*)malloc(4);
	bzero(right,4);
	fp=fopen("sbox","r");
	for(i=0;i<8;i++)
	{
	row=0;col=0;
	row = getbit(right_data[5-(j-1)/8],(j-1)%8+1);
	row = row<<1;
	row|= getbit(right_data[5-(j+4)/8],(j+4)%8+1);
	for(k=4;k>0;k--)
	{
	col|= getbit(right_data[5-(j+k-1)/8],(j+k-1)%8+1);
	if (k==1) break;
	col = col<<1;
	}
	fseek(fp,i*sizeof(table),0);
	fread(&table,sizeof(table),1,fp);
	right[3-(i/2)]|=get_val(table.s[row][col]);
	if(i%2==0)
	right[3-(i/2)]<<4;
	j+=6;
	}
	fclose(fp);
	return(right);
}	

char* p_box(char *ptr)
{
   char *p;
   p = (char*)malloc(4);
   change(ptr,p,1,9);
   change(ptr,p,2,17);
   change(ptr,p,3,23);
   change(ptr,p,4,31);
   change(ptr,p,5,13);
   change(ptr,p,6,28);
   change(ptr,p,7,2);
   change(ptr,p,8,18);
   change(ptr,p,9,24);
   change(ptr,p,10,16);
   change(ptr,p,11,30);
   change(ptr,p,12,6);
   change(ptr,p,13,26);
   change(ptr,p,14,20);
   change(ptr,p,15,10);
   change(ptr,p,16,1);
   change(ptr,p,17,8);
   change(ptr,p,18,14);
   change(ptr,p,19,25);
   change(ptr,p,20,3);
   change(ptr,p,21,4);
   change(ptr,p,22,29);
   change(ptr,p,23,11);
   change(ptr,p,24,19);
   change(ptr,p,25,32);
   change(ptr,p,26,12);
   change(ptr,p,27,22);
   change(ptr,p,28,7);
   change(ptr,p,29,5);
   change(ptr,p,30,27);
   change(ptr,p,31,15);
   change(ptr,p,32,21);
   return(p);
}
void make_key(char *key,char *key_48,int cycleno)
{
	char key_temp[7];
	bcopy(key,key_temp,7);
	   if(cycleno == 1 || cycleno == 2 || cycleno == 16)
	      rotate(key_temp,1);
	   else
	      rotate(key_temp,2);
	select48(key_temp,key_48);     
}
char* f(char *right,char* keyi)
{
	char* temp;
	int i;
	temp = expansion_permute(right);  
	for(i=0;i<6;i++)
	temp[i] ^= keyi[i];
	right= s_box(temp);
	right= p_box(right);
	return(right);
}

char*  en_cycle(char *key,int cycleno,char *data)
{
	int i;
	char *key_48,*new,*right;
	char key_temp[7];
	int row,col;
	key_48 = (char*)malloc(sizeof(char)*6);
	new = (char*)malloc(sizeof(char)*8); 
	for(i=0;i<4;i++)
	   new[i] = data[i+4];
	right=data+4;
	make_key(key,key_48,cycleno);
	right=f(right,key_48);
	for(i=0;i<4;i++)
	   new[i+4] =data[i]^right[i];
        return(new);
} 
char*  dec_cycle(char *key,int cycleno,char *data)
{
	int i;
	char *key_48,*new,*temp;
	char key_temp[7];
	int row,col;
	key_48 = (char*)malloc(sizeof(char)*6);
	new = (char*)malloc(sizeof(char)*8); 
	for(i=0;i<4;i++)
	   new[i+4] = data[i];
	make_key(key,key_48,cycleno);
	temp=f(data,key_48);
	for(i=0;i<4;i++)
	   new[i] =data[i+4]^temp[i];
        return(new);
} 
char * encrypt(char * data,char*key)
{
	char* temp,*compkey;
	int i,j,n=1;
	compkey = key_compression(key);  
	temp = initial_permute(data);
	for(i=1;i<=N;i++) 
	  temp = en_cycle(compkey,i,temp); 
        temp=inverse_permute(temp);
	return(temp);
}
char* decrypt(char *data,char*key)
{
	char* temp,*compkey,*temp1;
	int i,j,n=1;
	compkey = key_compression(key);  
	temp = initial_permute(data);
	for(i=N;i>=1;i--) 
	  temp = dec_cycle(compkey,i,temp); 
        temp=inverse_permute(temp);
	return(temp);
}

char* encode(char* data,char *key,char* IV,int length)
{
	int i,j;
	char *endata;
	endata=(char*)malloc(sizeof(char)*length);
	for(i=0;i<8;i++)
		data[i]^=IV[i];
		bcopy(encrypt(data,key),endata,8);
	for(j=1;j<length/8;j++)
	{
		for(i=0;i<8;i++)
			data[i+j*8]^=endata[i+(j-1)*8];
		bcopy(encrypt(data+j*8,key),endata+j*8,8);
	}
	return(endata);
}
char* decode(char* endata,char *key,char* IV,int length)
{
 	int i,j;
	char *data;
	data=(char*)malloc(sizeof(char)*length);

	for(j=length/8-1;j>0;j--)
	{
	bcopy(decrypt(endata+j*8,key),data+j*8,8);
	for(i=0;i<8;i++)
		data[i+j*8]^=endata[i+(j-1)*8];
	}
	bcopy(decrypt(endata,key),data,8);
	for(i=0;i<8;i++)
		data[i]^=IV[i];
	return(data);
}
	
