/* server process */

#include "inet.h"
#include "deff.h"
#include "key_block.h"

void error(char *p)
{
   printf("\nerror in %s",p);
   exit(0);
}

main()
{
   int	sockfd,i,seq_num=0;
   struct sockaddr_in    cli_addr,serv_addr;
   parameters p;
   SHD shd;
   char* temp_mac;
   cipher c;
   generic gb;
   SH ser;
   CH cli;
   FILE *fp;
   int clilen=sizeof(cli_addr);
   char premaster_secret[20];
   char cli_public[130],ser_public[130],keys[130];
   int len;
   char *server_response;
   FD fd; 
   char private_key[130];
   char *client_response;
  // strcpy(private_key,"1a2b3c4d5e6f7a8b1a553c4d5e8f7a8b152b5c4d5e6f7a8b1a7b3c4d5e6f748b1a2b3c4d566f7a8b1a2b3c4d5e6f7a8b1a2b3c4d5e6f7a8b1a2b3c4d5e6f7a8b");
 	system("clear");
	printf("login: ");
	scanf("%s",cli_public);
	printf("password: ");
	system("stty -echo");
	scanf("%s",private_key);
	system("stty echo");
	bcopy(cli_public,private_key+strlen(private_key),strlen(cli_public));
	client_response=(char*)malloc(sizeof(char)*(130+sizeof(CCS)+sizeof(FD)));
        if( (sockfd = socket(AF_INET,SOCK_DGRAM,0)) < 0)
     	   error("\n server error in socket creation");

	bzero((char *) &serv_addr,sizeof(serv_addr));
        serv_addr.sin_family = AF_INET;
   	serv_addr.sin_addr.s_addr = htonl(INADDR_ANY);
   	serv_addr.sin_port = htons(SERV_UDP_PORT);
  
	if(bind(sockfd,(struct sockaddr *) &serv_addr,sizeof(serv_addr))<0)
		error("\n bind error ");

	printf("\n server running ");
	
	initialize(&p);
	if((recvfrom(sockfd,&cli,sizeof(cli),0,(struct sockaddr*)&cli_addr,&clilen))<0)
		error("recieving client hello");
	else
		printf("recieved client hello\n");
	
    	response(&ser,&cli);
   	bcopy(ser.random,p.server_random,16);
   	bcopy(cli.random,p.client_random,16);
   	p.key_refresh=ser.key_refresh;

 	len=deff(ser_public,cli.key_id.dh_g,private_key,cli.key_id.dh_p);
	server_response=form_server_message(&ser,ser_public,&shd);
	

 	if((sendto(sockfd,server_response,sizeof(SH)+sizeof(SHD)+130,0,(struct sockaddr*)&cli_addr,sizeof(cli_addr)))!=sizeof(SH)+sizeof(SHD)+130)
		error("sending server response");
	else
		printf("sent server response\n");
	
	
	if((recvfrom(sockfd,client_response,130+sizeof(CCS)+sizeof(FD),0,(struct sockaddr*)&cli_addr,&clilen))<0)
		error("recieving client response");
	else
		printf("recieved client response\n");
	bcopy(client_response,cli_public,130);
 	len=deff(keys,cli_public,private_key,cli.key_id.dh_p);
	bcopy(keys,premaster_secret,20);
	printf("The premaster secret in server is \n");
	disp(premaster_secret,20);
	
	bcopy(calculate_master(premaster_secret,p.client_random,p.server_random),p.master_secret,20);
	printf("The master secret for server is \n");
	disp(p.master_secret,20);
	
       	calculate(&p,seq_num,"client expansion",client);
	calculate(&p,seq_num,"server expansion",server);  
	if(!check_client_response(client_response,&cli,server_response,cli_public,&p))
	{
		printf("\n error in client response message\n");
		close(sockfd);
		exit(1);
	}
	else
	{
		calculate_server_finished(&fd,&cli,server_response,client_response,p.master_secret);
 		if((sendto(sockfd,(char*)&fd,sizeof(FD),0,(struct sockaddr*)&cli_addr,sizeof(cli_addr)))!=sizeof(FD))
			error("sending server finished message");
		else
			printf("sent server finished\n");
	}
	for(;;)
	{
	if(seq_num%p.key_refresh==0)
	{
        calculate(&p,seq_num,"client expansion",client);
	calculate(&p,seq_num,"server expansion",server);  
	}
	if((recvfrom(sockfd,(char*)&c,sizeof(c),0,(struct sockaddr*)&cli_addr,&clilen))<0)
	error("error in recieving client encoded mesg");
	bcopy(decode(c.fragment,p.client_key,p.client_iv,c.length),(char*)&gb,c.length);	
	temp_mac=hmac_sha(p.client_mac_secret,gb.content,gb.length);
	if(strncmp(gb.mac,temp_mac,20)!=0)
	{
	printf("The integrity of the of the following message has changed\n");
	close(fd);
	exit(1);
	}
        for(i=0;i<gb.length;i++) 
	 putchar(gb.content[i]);
        seq_num++;
	}
}
